import java.util.Scanner;
import java.util.InputMismatchException;
import java.sql.Timestamp;

public class MergeSort{
	
	//MergeSort implemented by Colin Wack
	
	//variable declaration
	private static int[] array;
	private static Scanner in;
	private static boolean finished;
	private static int index;
	private static boolean goodInput;
	private static String input;
	private static Timestamp timestamp;
	private static long start;
	private static long end;
	
	public static void main(String[] args) throws InputMismatchException{
		timestamp = new Timestamp(0);
		in = new Scanner(System.in);
		System.out.println("Welcome to Merge Sorting!");
		System.out.println();
		do{
			//asks how many elements to sort
			do{
				System.out.println("How many elements would you like to sort?");
				try{
					index = in.nextInt();
					if (index >= 0){
						goodInput = true;
					}
					else {
						goodInput = false;
						System.out.println("I'm sorry, we need an integer greater than 0.");
					}
					if (index == 0){
						System.out.println("0? Really? REALLY? Wow. Seriously? Wooooooow.");
					}
				}
				catch (InputMismatchException e){
					System.out.println("I'm sorry, we need an integer greater than 0.");
					goodInput = false;
					in.nextLine();
				}
			}
			while (!goodInput);
		
			//fills array with elements
			array = new int[index];
			for (int i = 0; i < array.length; ++i){
				System.out.println("Next number?");
				do{
					try {
						array[i] = in.nextInt();
						goodInput = true;
					}
					catch (InputMismatchException e){
						in.nextLine();
						goodInput = false;
						System.out.println("I'm sorry, we need an integer.");
					}
				}
				while (!goodInput);
			}
			
			printArray(array);
			printArray(sort(array));
			
			//asks if the user wishes to try again
			do{
				System.out.println("Again? (Y or N)");
				input = in.next();
				
				if (input.equalsIgnoreCase("Y")){
					goodInput = true;
					finished = false;
				}
				else {
					if (input.equalsIgnoreCase("N")){
						goodInput = true;
						finished = true;
					}
					else {
						goodInput = false;
						System.out.println("Pardon?");
					}
				}
			}
			while (!goodInput);
		
		}
		while (!finished);
	}

	public static void printArray(int[] array){

		//a simple loop to print our array
		for (int i = 0; i < array.length; ++i){
			System.out.print(array[i]);
			if (i < array.length - 1){
				System.out.print(", ");
			}
		}
		System.out.print("\n");
	}

	public static int[] sort(int[] a){
		
		//base case: if there are less than 2 elements, it is sorted.
		if (a.length <= 1){	
			return a;
		}
				
		//divide our array in half, then put each half into its own subarray.
		int[] b = new int[a.length/2];
		int[] c = new int[a.length - b.length];
		for (int i = 0; i < a.length; ++i){
			if (i < b.length){
				b[i] = a[i];
			}
			else {
				c[i - b.length] = a[i];
			}
		}
		
		//sort our subarrays.
		b = sort(b);
		c = sort(c);
		
		//compare the smallest values of our subarrays, and insert the smallest 
		//into the next available location in our main array.
		int indexB = 0;
		int indexC = 0;
		for (int i = 0; i < a.length; ++i){
			if (indexC < c.length && indexB < b.length){
				if (b[indexB] < c[indexC]){	
					a[i] = b[indexB];
					++indexB;
				}
				else {
					a[i] = c[indexC];
					++indexC;
				}
			}
			else {
				if (indexB >= b.length){
					a[i] = c[indexC];
					++indexC;
				}
				else {
					a[i] = b[indexB];
					++indexB;
				}
			}
		}
		
		//finished! return our sorted array.
		return a;
	}
}