import java.util.Scanner;
import java.util.InputMismatchException;
import java.util.Random;

public class QuickSort{
	
	//QuickSort implemented by Colin Wack
	
	//variable declaration
	private static int[] array;
	private static Scanner in;
	private static boolean finished;
	private static int index;
	private static boolean goodInput;
	private static String input;
	private static Random random;
	
	public static void main(String[] args) throws InputMismatchException{
		in = new Scanner(System.in);
		random = new Random();
		System.out.println("Welcome to Quick Sorting!");
		System.out.println();
		do{
			//asks how many elements to sort
			do{
				System.out.println("How many elements would you like to sort?");
				try{
					index = in.nextInt();
					if (index >= 0){
						goodInput = true;
					}
					else {
						goodInput = false;
						System.out.println("I'm sorry, we need an integer greater than 0.");
					}
					if (index == 0){
						System.out.println("0? Really? REALLY? Wow. Seriously? Wooooooow.");
					}
				}
				catch (InputMismatchException e){
					System.out.println("I'm sorry, we need an integer greater than 0.");
					goodInput = false;
					in.nextLine();
				}
			}
			while (!goodInput);
		
			//fills array with elements
			array = new int[index];
			for (int i = 0; i < array.length; ++i){
				System.out.println("Next number?");
				do{
					try {
						array[i] = in.nextInt();
						goodInput = true;
					}
					catch (InputMismatchException e){
						in.nextLine();
						goodInput = false;
						System.out.println("I'm sorry, we need an integer.");
					}
				}
				while (!goodInput);
			}
			
			printArray(array);
			printArray(sort(array));
			
			
			//asks if the user wishes to try again
			do{
				System.out.println("Again? (Y or N)");
				input = in.next();
				
				if (input.equalsIgnoreCase("Y")){
					goodInput = true;
					finished = false;
				}
				else {
					if (input.equalsIgnoreCase("N")){
						goodInput = true;
						finished = true;
					}
					else {
						goodInput = false;
						System.out.println("Pardon?");
					}
				}
			}
			while (!goodInput);
		
		}
		while (!finished);
	}

	public static void printArray(int[] array){
		
		//simple loop to print array
		for (int i = 0; i < array.length; ++i){
			System.out.print(array[i]);
			if (i < array.length - 1){
				System.out.print(", ");
			}
		}
		System.out.print("\n");
	}

	public static int[] sort(int[] a){
		
		//base case: if there are less than 2 elements, it is sorted.
		if (a.length <= 1){	
			return a;
		}
		
		
		//this part is required for primitive arrays; it counts how many 
		//elements must go into each subarray, so we know how big to make it.
		//we do this because it is a pain to compensate for extra or missing space.
		int indexB = 0;
		int indexC = 0;
		int pivot = random.nextInt(a.length);
		int pivotValue = a[pivot];
		for (int i = 0; i < a.length; ++i){
			if (i != pivot){
				if (a[i] < a[pivot]){
					++indexB;
				}
				else ++indexC;
			}
			
		}
		
		//Put all values less than our randomly chosen pivot value into one subarray, 
		//and all values greater than (or equal to, save for one) into another subarray.
		int[] b = new int[indexB];
		int[] c = new int[indexC];
		indexB = 0;
		indexC = 0;
		for (int i = 0; i < a.length; ++i){
			if (i != pivot){
				if (a[i] < a[pivot]){
					b[indexB] = a[i];
					if (indexB < b.length - 1){
						++indexB;
					}
				}
				else{
					c[indexC] = a[i];
					if (indexC < c.length - 1){
						++indexC;
					}
				}
			}
		}
		
		//sort the subarrays.
		b = sort(b);
		c = sort(c);
		
		//retrieve all elements in the smaller sorted subarray and insert them into our main array,
		//then insert the pivot value, then insert all elements in the larger sorted subarray.
		boolean pivotInserted = false;
		indexB = 0;
		indexC = 0;
		for (int i = 0; i < a.length; ++i){
			if (indexB < b.length){
				a[i] = b[indexB];
				++indexB;
			}
			else {
				if (!pivotInserted){
					a[i] = pivotValue;
					pivotInserted = true;
				}
				else {
					a[i] = c[indexC];
					++indexC;
				}
			}
		}
		
		//finished! return our sorted array.
		return a;
	}
}